﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Data;
using System.Diagnostics;
using System.Data.SqlClient;
using Mvc5TreeGridSample.Models;
using System.Data.Entity.Infrastructure;
using System.Web.Configuration;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.Shared.Serializer;

namespace Mvc5TreeGridSample.Controllers
{   

    public class myDropDown
    {
        public string ResourceID { get; set; }       
        public string ddtext { get; set; }
    }

    public class TreeGridController : Controller
    {                
        private GanttDatabase2008Entities db = new GanttDatabase2008Entities();        
        public ActionResult Index()
        {
            var data = db.GanttDataTables.ToList();          
            var resource = dropdown();
            ViewBag.resources = resource;
            ViewBag.dataSource1 = data;
            return View();
        }


        public static IEnumerable<object> dropdown()
        {            
            JavaScriptSerializer TheSerializer = new JavaScriptSerializer();
            List<myDropDown> resourceDetails = new List<myDropDown>();
            resourceDetails.Add(new myDropDown() { ResourceID = "1", ddtext = "Project Manager" });
            resourceDetails.Add(new myDropDown() { ResourceID = "2", ddtext = "Software Analyst" });
            resourceDetails.Add(new myDropDown() { ResourceID = "3", ddtext = "Developer" });
            resourceDetails.Add(new myDropDown() { ResourceID = "4", ddtext = "Testing Engineer" });
            var resourceList = resourceDetails.ToList();
            var theJson = TheSerializer.Serialize(resourceDetails);
            return resourceList;
        }
       
        
        [HttpPost()]
        public void Update(TaskData Task, List<myDropDown> Resource)
        {
            try
            {
                string IDNumber = Task.TaskId;
                GanttDataTable data = db.GanttDataTables.First(i => i.TaskId == IDNumber);
                data.TaskId = Task.TaskId;
                data.TaskName = Task.TaskName;
                data.StartDate = Task.StartDate;
                data.EndDate = Task.EndDate;
                data.Duration = Task.Duration;
                data.Progress = Task.Progress;
                data.ParentId = Task.ParentId;
                data.ResourceID = this.GetResourceId(Resource);
                data.ResourceName = this.GetResourceValue(Resource);
                db.SaveChanges();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.InnerException);
            }                                      
        }

        [HttpPost()]
        public void Add(TaskData Task, List<myDropDown> Resource)
        {
            try
            {
                GanttDataTable newData = new GanttDataTable
                {
                TaskId = Task.TaskId,
                TaskName = Task.TaskName,
                StartDate = Task.StartDate,
                EndDate = Task.EndDate,
                Duration = Task.Duration,
                Progress = Task.Progress,
                ParentId = Task.ParentId,
                ResourceID = this.GetResourceId(Resource),
                ResourceName = this.GetResourceValue(Resource)
                };
                db.GanttDataTables.Add(newData);
                db.SaveChanges();               
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.InnerException);
            }
        }

        public string GetResourceId(List<myDropDown> Resources)
        {
            string text = "";
            bool isResourcePresent = true;
            if (Resources == null)
                isResourcePresent = false;
            if (Resources !=null && (Resources.Count == 0 || Resources[0] ==null))
                isResourcePresent = false;
            if (isResourcePresent)
            {
                foreach (var i in Resources)
                {
                    string changetext = i.ResourceID;
                    text += changetext + ",";
                }
            }
            return text;
        }
        public string GetResourceValue(List<myDropDown> Resources)
        {
            string text = "";
            bool isResourcePresent = true;
            if (Resources == null)
                isResourcePresent = false;
            if (Resources != null && (Resources.Count == 0 || Resources[0] == null))
                isResourcePresent = false;
            if (isResourcePresent)
            {
                foreach (var i in Resources)
                {
                    string changetext = i.ddtext;
                    text += changetext + ",";
                }
            }
            return text;
        }   
    }
}
